#ifndef CONFIGURE_H
#define CONFIGURE_H

/*
 * use FFTW or SPTK FFT ?
 * If you want to use FFTW, define USE_FFTW.
 * otherwise, undef USE_FFTW.
 */
#define USE_FFTW

namespace stand
{
const double A4Frequency = 440.0;
const int A4NoteNumber = 69;
const double DefaultFramePeriod = 2.0;
const int DefaultMFCCLength = 32;
const int DefaultSamplingFrequency = 44100;
const int DefaultFFTLength = 2048;
const char EditorName[] = "Echoes Editor";
enum ScaleType
{
    Unknown = -1,
    Linear = 0,
    Log
};

namespace sequence
{
const int DefaultTicksPerBeat = 480;
const int DefaultNumTracks = 1;
const double DefaultBeatsPerMinutes = 120.0;

static bool IsBlackKey[12] = {false, true, false, true, false, false, true, false, true, false, true, false};
static char* KeyName[12] = {"C",   "C#", "D",   "D#", "E",   "F",   "F#", "G",   "G#", "A",   "B-", "B"};
}
}

#endif // CONFIGURE_H
